RTREE=..\..\rtree
COMPILER=cc
CM=
D=SAPP
P=-I.\ -I..\ -I$(RTREE)
L=
AZL=-lm$(L) -lc$(L)
LN=ctalib
ALIB=$(LN).lib
LINK=ln

executables: $(D)\cttest.exe $(D)\ctexmc.exe $(D)\ctexmg.exe $(D)\ctvxmg.exe \
		 $(D)\ctixmg.exe $(D)\ctpkey.exe $(D)\ctflat.exe \
		 $(D)\ctcmpc.exe $(D)\ctrbld.exe
	echo DONE

$(D)\ctexmc.exe: $(D)\ctexmc.o $(D)\$(ALIB)
	cd $(D)
	$(LINK) -T ctexmc $(ALIB) $(AZL)
	cd ..

$(D)\ctexmc.o: ..\ctexmc.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctexmc.o ..\ctexmc.c

$(D)\ctexmg.exe: $(D)\ctexmg.o $(D)\$(ALIB)
	cd $(D)
	$(LINK) ctexmg $(ALIB) $(AZL)
	cd ..

$(D)\ctexmg.o: ..\ctexmg.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctexmg.o ..\ctexmg.c

$(D)\ctvxmg.exe: $(D)\ctvxmg.o $(D)\$(ALIB)
	cd $(D)
	$(LINK) ctvxmg $(ALIB) $(AZL)
	cd ..

$(D)\ctvxmg.o: ..\ctvxmg.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctvxmg.o ..\ctvxmg.c

$(D)\ctixmg.exe: $(D)\ctixmg.o $(D)\$(ALIB)
	cd $(D)
	$(LINK) ctixmg $(ALIB) $(AZL)
	cd ..

$(D)\ctixmg.o: ..\ctixmg.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctixmg.o ..\ctixmg.c

$(D)\cttest.exe: ..\cttest.c
	$(COMPILER) $(P) $(CM) -O $(D)\cttest.o -Z2250 ..\cttest.c
	cd $(D)
	$(LINK) cttest.o $(AZL)
	del cttest.o
	cd ..

$(D)\ctcmpc.exe: $(D)\ctcmpc.o $(D)\$(ALIB)
	cd $(D)
	$(LINK) ctcmpc.o $(ALIB) $(AZL)
	cd ..

$(D)\ctcmpc.o: ..\ctcmpc.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctcmpc.o ..\ctcmpc.c

$(D)\ctflat.exe: $(D)\ctflat.o $(D)\$(ALIB)
	cd $(D)
	$(LINK) ctflat.o $(ALIB) $(AZL)
	cd ..

$(D)\ctflat.o: ..\ctflat.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctflat.o ..\ctflat.c

$(D)\ctpkey.exe: $(D)\ctpkey.o $(D)\$(ALIB)
	cd $(D)
	$(LINK) ctpkey.o $(ALIB) $(AZL)
	cd ..

$(D)\ctpkey.o: ..\ctpkey.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctpkey.o ..\ctpkey.c

$(D)\ctrbld.exe: $(D)\ctrbld.o $(D)\$(ALIB)
	cd $(D)
	$(LINK) ctrbld.o $(ALIB) $(AZL)
	cd ..

$(D)\ctrbld.o: ..\ctrbld.c
	echo	CTRBLD CANNOT BE USED WITH FPUTFGET (create an entire NOTFORCE library)
	$(COMPILER) $(P) $(CM) -O $(D)\ctrbld.o ..\ctrbld.c

#library

$(D)\$(ALIB):	$(D)\ctibld.o $(D)\ctrbl2.o $(D)\ctvrc2.o \
			$(D)\ctdelk.o $(D)\ctaddk.o $(D)\ctupdt.o \
			$(D)\ctsrch.o $(D)\ctdatf.o $(D)\ctkeyf.o \
			$(D)\ctkrnl.o $(D)\ctcomp.o $(D)\ctvrcu.o \
			$(D)\ctinit.o $(D)\ctdelf.o $(D)\ctclb2.o \
			$(D)\ctclib.o $(D)\ctclb3.o $(D)\ctfrac.o \
			$(D)\ctsset.o $(D)\ctisam.o $(D)\ctvrec.o \
			$(D)\ctism2.o $(D)\ctestm.o $(D)\ctload.o \
			$(D)\ctismc.o $(D)\ctismo.o $(D)\cticre.o \
			$(D)\ctiopn.o \
			$(D)\cticls.o $(D)\ctifil.o \
			$(D)\ctismu.o
	cd $(D)
	del $(LN).bak
	ren $(ALIB) $(LN).bak
	lb $(ALIB)     ctibld.o ctrbl2.o ctsset.o ctisam.o ctvrec.o ctism2.o
	lb $(ALIB) -a+ ctismc.o ctismo.o cticre.o ctiopn.o cticls.o ctifil.o
	lb $(ALIB) -a+ ctismu.o ctvrc2.o ctload.o ctdelk.o ctaddk.o ctupdt.o ctestm.o
	lb $(ALIB) -a+ ctfrac.o ctsrch.o ctdatf.o ctkeyf.o ctkrnl.o ctcomp.o
	lb $(ALIB) -a+ ctvrcu.o ctinit.o ctdelf.o ctclb2.o ctclib.o ctclb3.o 
	cd ..

# library modules

$(D)\ctibld.o: ..\ctibld.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctibld.o ..\ctibld.c

$(D)\ctrbl2.o: ..\ctrbl2.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctrbl2.o ..\ctrbl2.c

$(D)\ctvrc2.o: ..\ctvrc2.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctvrc2.o ..\ctvrc2.c

$(D)\ctdelk.o: ..\ctdelk.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctdelk.o ..\ctdelk.c

$(D)\ctaddk.o: ..\ctaddk.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctaddk.o ..\ctaddk.c

$(D)\ctupdt.o: ..\ctupdt.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctupdt.o ..\ctupdt.c

$(D)\ctsrch.o: ..\ctsrch.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctsrch.o ..\ctsrch.c

$(D)\ctdatf.o: ..\ctdatf.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctdatf.o ..\ctdatf.c

$(D)\ctkeyf.o: ..\ctkeyf.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctkeyf.o ..\ctkeyf.c

$(D)\ctkrnl.o: ..\ctkrnl.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctkrnl.o ..\ctkrnl.c

$(D)\ctclb3.o: ..\ctclb3.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctclb3.o ..\ctclb3.c

$(D)\ctcomp.o: ..\ctcomp.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctcomp.o ..\ctcomp.c

$(D)\ctvrcu.o: ..\ctvrcu.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctvrcu.o ..\ctvrcu.c

$(D)\ctinit.o: ..\ctinit.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctinit.o ..\ctinit.c

$(D)\ctdelf.o: ..\ctdelf.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctdelf.o ..\ctdelf.c

$(D)\ctload.o: ..\ctload.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctload.o ..\ctload.c

$(D)\ctfrac.o: ..\ctfrac.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctfrac.o ..\ctfrac.c

$(D)\ctestm.o: ..\ctestm.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctestm.o ..\ctestm.c

$(D)\ctclb2.o: ..\ctclb2.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctclb2.o ..\ctclb2.c

$(D)\ctclib.o: ctclib.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctclib.o ctclib.c

$(D)\ctsset.o: ..\ctsset.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctsset.o ..\ctsset.c

$(D)\ctisam.o: ..\ctisam.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctisam.o ..\ctisam.c

$(D)\ctvrec.o: ..\ctvrec.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctvrec.o ..\ctvrec.c

$(D)\ctism2.o: ..\ctism2.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctism2.o ..\ctism2.c

$(D)\ctismc.o: ..\ctismc.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctismc.o ..\ctismc.c

$(D)\ctismo.o: ..\ctismo.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctismo.o ..\ctismo.c

$(D)\cticre.o: ..\cticre.c
	$(COMPILER) $(P) $(CM) -O $(D)\cticre.o ..\cticre.c

$(D)\ctiopn.o: ..\ctiopn.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctiopn.o ..\ctiopn.c

$(D)\cticls.o: ..\cticls.c
	$(COMPILER) $(P) $(CM) -O $(D)\cticls.o ..\cticls.c

$(D)\ctifil.o: ..\ctifil.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctifil.o ..\ctifil.c

$(D)\ctismu.o: ..\ctismu.c
	$(COMPILER) $(P) $(CM) -O $(D)\ctismu.o ..\ctismu.c

# end
